--- u-boot-2011.06_original/common/cmd_cncflash.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/common/cmd_cncflash.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,657 @@
+#include <common.h>
+#include <command.h>
+#include <malloc.h>
+#include <image.h>
+#include <asm/byteorder.h>
+#include <usb.h>
+#include <jffs2/jffs2.h>
+#include <nand.h>
+#include "cnc_util.h"
+
+typedef enum FLASH_MODE
+{
+	FLASH_MODE_READ=0,
+	FLASH_MODE_WRITE,
+	FLASH_MODE_ERASE,
+	FALSH_MODE_VERFIFY,
+	FLASH_MODE_INVALID=-1
+}FLASH_MODE;
+
+typedef enum MTD_ID
+{
+	MTD_ID_NAND_FLASH=0,
+	MTD_ID_SPI_FLASH,
+	MTD_ID_NOR_FLASH,
+	MTD_ID_EMMC_FLASH,
+	MTD_ID_INVALID=-1
+}MTD_ID;
+
+const char* CncValidMtdIdList[] = 
+{
+	"cnc-nand",
+	"s25f",
+	"cnc-spi"
+	"cnc-nor",
+	"emmc",
+	NULL
+};
+
+const char* FlashModeList[] =
+{
+	"read",
+	"write",
+	"erase",
+	"verify",
+	NULL,
+};
+
+extern int GetSizeAndOffset(const char* pBuf, int* apSize, int *apOffset);
+extern int GenerateImagePartitionListFromBootArgs(const char* apBootArgs, ImagePartitionList_t *apImagePartitionList);
+
+int GetSizeAndOffset(const char* pBuf, int* apSize, int *apOffset)
+{
+    //xx@yy
+    char TempBuf[16]={0};
+    char* p1;
+    //char* p2;
+    int multiplier=1;
+    
+    //printf("GetSizeAndOffset%s\n", pBuf);
+
+    strncpy(TempBuf, pBuf, sizeof(TempBuf) );
+
+    p1 = strstr(TempBuf, "@" );
+    if (p1 == NULL) return -1;
+
+    TempBuf[p1-TempBuf]='\0';
+    switch ( TempBuf [ strlen(TempBuf )-1] )
+    {
+        case 'k':
+            multiplier = 1024;
+            break;
+        case 'm':
+            multiplier = 1024*1024;
+            break;
+        case 'g':
+            multiplier=1024*1024*1024;
+            break;
+    }
+    *apSize = simple_strtol(TempBuf,NULL,10 )* multiplier ;   
+
+    p1++;
+    multiplier=1;
+    switch ( *(p1 + strlen(p1)-1 ) )
+    {
+        case 'k':
+            multiplier = 1024;
+            break;
+        case 'm':
+            multiplier = 1024*1024;
+            break;
+        case 'g':
+            multiplier=1024*1024*1024;
+            break;
+    }
+    *apOffset = simple_strtol(p1,NULL,10 )* multiplier ;  
+    return 0;
+
+}
+
+
+//bootargs="root=/dev/mtdblock4 rootfstype=jffs2 console=ttyS0,115200 mtdparts=s25f:56k@0k(miniloader),8k@56k(env);cnc-nand:1m@0m(free1),2m@1m(logo),6m@3m(failsafekernel),1m@9m(uboot2),4m@10m(kernel),100m@14m(rootfs),100m@114m(update),42m@214m(user)" --image1 "name=miniloader, secure=1, nand=0, erase_write=1, version=r45345, image=./test1.bin" --image2 "name=kernel, secure=1, nand=1, erase_write=1, version=r99, image=./test2.bin"
+//bootargs="root=/dev/mtdblock4 rootfstype=jffs2 console=ttyS0,115200
+//         mtdparts=s25f:56k@0k(miniloader),8k@56k(env);cnc-nand:1m@0m(free1),2m@1m(logo),6m@3m(failsafekernel),1m@9m(uboot2),4m@10m(kernel),100m@14m(rootfs),100m@114m(update),42m@214m(user)" --image1 "name=miniloader, secure=1, nand=0, erase_write=1, version=r45345, image=./test1.bin" --image2 "name=kernel, secure=1, nand=1, erase_write=1, version=r99, image=./test2.bin"
+int GenerateImagePartitionListFromBootArgs(const char* apBootArgs, ImagePartitionList_t *apImagePartitionList)
+{
+	int Status = -1;
+    const char* p1 = apBootArgs;
+    int pos = 0;
+    const char* p2 ;
+    char TempBuf[512];
+    int size;
+    int offset;
+
+    int i=0;
+    int j=0;
+
+
+    p2 = strstr(p1, SPI_TOKEN );
+    if (p2 != NULL )
+    {
+        //spi parition info exist...
+        p2 = strstr(p2,":");
+        if ( NULL == p2)
+        {
+            return Status;
+        }
+        p2 = p2 + strlen( ":" );
+
+        i=0;
+        j=0;
+	TempBuf[0]='\0';
+	strncpy(TempBuf,p2,512);
+	p2=strtok(TempBuf," ");
+        while(  (  *(p2+i) != ';') && 
+                ( *(p2+i) != '\0' ) && 
+                ( *(p2+i) != ' ' ) &&
+                ( *(p2+i) != '\"' )
+             )
+        {
+			if ( j >= sizeof(TempBuf) )
+			{
+				return -1;
+			}
+			
+            TempBuf[j] = * (p2+i);
+            i++;
+
+            if (TempBuf[j] == '(' )
+            {
+                TempBuf[j]='\0';
+                Status = GetSizeAndOffset(TempBuf,& size, & offset);
+                if (Status == -1 )
+                {
+                    return -1;
+                }
+                apImagePartitionList->mImagePartitionList[pos].mFlashAddress = offset;
+                apImagePartitionList->mImagePartitionList[pos].mLength  = size    ;
+                j=0;
+                continue;
+            }
+            else if (TempBuf[j] == ')' )
+            {
+                TempBuf[j]='\0';
+                strcpy(apImagePartitionList->mImagePartitionList[pos].mPartionName , TempBuf);
+                strcpy(apImagePartitionList->mImagePartitionList[pos].mMtdId , SPI_TOKEN );
+                j=0;
+                continue;
+            }
+            else if ( TempBuf[j] == ',' )
+            {
+                j=0;
+                pos++;
+                continue;
+            }
+            j++;
+        }
+    }
+
+	if (p2 != NULL )
+	{
+		if ( *(p2+i) == ';')
+		{
+			pos++;
+		}
+	}
+
+	i=0;
+    j=0;
+    p2 = strstr(p1, "emmc" );
+    if (p2 != NULL )
+    {
+        //emmc parition info exist...
+        p2 = strstr(p2,":");
+        if ( NULL == p2)
+        {
+            return Status;
+        }
+        p2 = p2 + strlen( ":" );
+
+        i=0;
+        j=0;
+	TempBuf[0]='\0';
+	strncpy(TempBuf,p2,512);
+	p2=strtok(TempBuf," ");
+        while(  (  *(p2+i) != ';') && 
+                ( *(p2+i) != '\0' ) && 
+                ( *(p2+i) != ' ' ) &&
+                ( *(p2+i) != '\"' )
+             )
+        {
+			if ( j >= sizeof(TempBuf) )
+			{
+				return -1;
+			}
+			
+            TempBuf[j] = * (p2+i);
+            i++;
+
+            if (TempBuf[j] == '(' )
+            {
+                TempBuf[j]='\0';
+                Status = GetSizeAndOffset(TempBuf,& size, & offset);
+                if (Status == -1 )
+                {
+                    return -1;
+                }
+                apImagePartitionList->mImagePartitionList[pos].mFlashAddress = offset;
+                apImagePartitionList->mImagePartitionList[pos].mLength  = size    ;
+                j=0;
+                continue;
+            }
+            else if (TempBuf[j] == ')' )
+            {
+                TempBuf[j]='\0';
+                strcpy(apImagePartitionList->mImagePartitionList[pos].mPartionName , TempBuf);
+                strcpy(apImagePartitionList->mImagePartitionList[pos].mMtdId , "emmc" );
+                if( *(p2+i) == '\0' )
+                {
+                	pos++;
+                }
+                j=0;
+                continue;
+            }
+            else if (TempBuf[j] == ',' )
+            {
+                j=0;
+                pos++;
+                continue;
+            }
+            j++;
+        }
+    }
+	if (p2 != NULL )
+	{
+		if ( *(p2+i) == ';')
+		{
+			pos++;
+		}
+	} 
+
+	i=0;
+    j=0;
+    p2 = strstr(p1, "cnc-nand" );
+    if (p2 != NULL )
+    {
+        //cnc-nand parition info exist...
+        p2 = strstr(p2,":");
+        if ( NULL == p2)
+        {
+            return Status;
+        }
+        p2 = p2 + strlen( ":" );
+
+        i=0;
+        j=0;
+	TempBuf[0]='\0';
+	strncpy(TempBuf,p2,512);
+	p2=strtok(TempBuf," ");
+        while(  (  *(p2+i) != ';') && 
+                ( *(p2+i) != '\0' ) && 
+                ( *(p2+i) != ' ' ) &&
+                ( *(p2+i) != '\"' )
+             )
+        {
+			if ( j >= sizeof(TempBuf) )
+			{
+				return -1;
+			}
+			
+            TempBuf[j] = * (p2+i);
+            i++;
+
+            if (TempBuf[j] == '(' )
+            {
+                TempBuf[j]='\0';
+                Status = GetSizeAndOffset(TempBuf,& size, & offset);
+                if (Status == -1 )
+                {
+                    return -1;
+                }
+                apImagePartitionList->mImagePartitionList[pos].mFlashAddress = offset;
+                apImagePartitionList->mImagePartitionList[pos].mLength  = size    ;
+                j=0;
+                continue;
+            }
+            else if (TempBuf[j] == ')' )
+            {
+                TempBuf[j]='\0';
+                strcpy(apImagePartitionList->mImagePartitionList[pos].mPartionName , TempBuf);
+                strcpy(apImagePartitionList->mImagePartitionList[pos].mMtdId , "cnc-nand" );
+                if( *(p2+i) == '\0' )
+                {
+                	pos++;
+                }
+                j=0;
+                continue;
+            }
+            else if (TempBuf[j] == ',' )
+            {
+                j=0;
+                pos++;
+                continue;
+            }
+            j++;
+        }
+    }
+	if (p2 != NULL )
+	{
+		if ( *(p2+i) == '\"')
+		{
+			pos++;
+		}
+	}
+    apImagePartitionList->mNoOfPartition = pos;
+	return Status;	
+}
+
+
+int SearchExactStringInList(const char* pBuffer, const char* aList[])
+{
+	int i;
+
+	i=0;
+	
+	while ( aList[i] != NULL)
+	{		
+		if ( 0 == strcmp( pBuffer, aList[i] ) )
+		{
+			return i;
+		}		
+		i++;
+	}	
+	return -1;
+}
+
+int GetPartiotioIndex(  ImagePartitionList_t * apImagePartitionList, const char* apMtdId, const char* apPartitionName )
+{
+	int i;
+	for(i=0;i <	apImagePartitionList->mNoOfPartition; i++)
+	{
+		if( ( 0 == strcmp( apImagePartitionList->mImagePartitionList[i].mMtdId , apMtdId ) ) &&
+		    ( 0 == strcmp( apImagePartitionList->mImagePartitionList[i].mPartionName, apPartitionName ) )
+		  )
+		{
+			return i;
+		}
+	}
+	return -1;
+}
+
+void PrintUsage(cmd_tbl_t *cmdtp)
+{
+	cmd_usage(cmdtp);
+}
+
+
+int CncFlashTask( FLASH_MODE aFlashMode, MTD_ID  aMtdId , ImagePartition_t *apImagePartition , UInt32 aDdrAddress)
+{
+	int Status=-1;
+	switch (aFlashMode)
+	{
+		case FLASH_MODE_INVALID:
+		{
+			printf("%sERROR: Invalid FLASH_MODE supplied%s\n", ColorRed, ColorNormal);
+			return -1;
+		}
+		break;
+		
+		case FLASH_MODE_READ:
+		{
+			switch ( aMtdId)
+			{
+				case MTD_ID_NAND_FLASH:
+				{
+					Status = cnc_NandRead(apImagePartition->mFlashAddress ,
+								apImagePartition->mDdrAddress , 								 
+								apImagePartition->mLength);
+					
+				}
+				break;
+				case MTD_ID_SPI_FLASH:
+				{
+					Status = cnc_SpiRead(apImagePartition->mFlashAddress , 
+								apImagePartition->mDdrAddress ,								
+								apImagePartition->mLength);
+				}
+				break;
+				case MTD_ID_NOR_FLASH:
+				{
+					Status = cnc_NorRead(apImagePartition->mFlashAddress , 
+								apImagePartition->mDdrAddress ,								
+								apImagePartition->mLength);
+				}
+				break;
+				case MTD_ID_EMMC_FLASH:
+				{
+					Status = cnc_EMMCRead(apImagePartition->mFlashAddress , 
+								apImagePartition->mDdrAddress ,								
+								apImagePartition->mLength);
+				}
+				break;
+				case MTD_ID_INVALID:
+				{
+					printf("%sERROR: Invalid MTD_ID supplied%s\n", ColorRed, ColorNormal);
+					return -1;
+				}
+				break;
+			}
+		}
+		break;
+		
+		case FLASH_MODE_WRITE:
+		{
+			switch ( aMtdId)
+			{
+				case MTD_ID_NAND_FLASH:
+				{	
+					Status = cnc_NandWrite( apImagePartition->mDdrAddress , 
+								apImagePartition->mFlashAddress , 
+								apImagePartition->mLength,
+								0 /* do no spread , because we are erasing entire mtd region*/
+							);
+				}
+				break;
+				case MTD_ID_SPI_FLASH:
+				{
+					Status = cnc_SpiWrite( apImagePartition->mDdrAddress , 
+								apImagePartition->mFlashAddress , 
+								apImagePartition->mLength
+							);
+				}
+				break;
+				case MTD_ID_NOR_FLASH:
+				{
+					Status = cnc_NorWrite( apImagePartition->mDdrAddress , 
+								apImagePartition->mFlashAddress , 
+								apImagePartition->mLength
+							);
+				}
+				break;
+				case MTD_ID_EMMC_FLASH:
+				{
+					Status = cnc_EMMCWrite( apImagePartition->mDdrAddress , 
+								apImagePartition->mFlashAddress , 
+								apImagePartition->mLength, 0
+							);
+				}
+				break;
+				case MTD_ID_INVALID:
+				{
+					printf("%sERROR: Invalid MTD_ID supplied%s\n", ColorRed, ColorNormal);
+					return -1;
+				}
+				break;
+				
+			}
+		}
+		break;
+		case FLASH_MODE_ERASE:
+		{
+			switch ( aMtdId)
+			{
+				case MTD_ID_NAND_FLASH:
+				{
+					Status = cnc_NandErase( apImagePartition->mFlashAddress , apImagePartition->mLength, 0	);//use nand erase only. don't use erase.spread
+				}
+				break;
+				case MTD_ID_SPI_FLASH:
+				{
+					Status = cnc_SpiErase( apImagePartition->mFlashAddress , apImagePartition->mLength	);
+				}
+				break;
+				case MTD_ID_NOR_FLASH:
+				{
+					Status = cnc_NorErase( apImagePartition->mFlashAddress , apImagePartition->mLength	);
+				}
+				break;
+				case MTD_ID_EMMC_FLASH:
+				{
+//					Status = cnc_NorErase( apImagePartition->mFlashAddress , apImagePartition->mLength	);
+					printf("eMMC does not need to erase\n");
+					Status = 0;
+				}
+				break;
+				case MTD_ID_INVALID:
+				{
+					printf("%sERROR: Invalid MTD_ID supplied%s\n", ColorRed, ColorNormal);
+					return -1;
+				}
+				break;
+				
+			}
+		}
+		break;
+		case FALSH_MODE_VERFIFY:
+		{
+			switch ( aMtdId)
+			{
+				case MTD_ID_NAND_FLASH:
+				{
+					Status = cnc_NandVerify( apImagePartition->mDdrAddress , 
+								apImagePartition->mFlashAddress , 
+								apImagePartition->mLength
+							);
+				}
+				break;
+				case MTD_ID_SPI_FLASH:
+				{
+					Status = cnc_SpiVerify( apImagePartition->mDdrAddress , 
+								apImagePartition->mFlashAddress , 
+								apImagePartition->mLength
+							);
+				}
+				break;
+				case MTD_ID_NOR_FLASH:
+				{
+					Status = cnc_NorVerify( apImagePartition->mDdrAddress , 
+								apImagePartition->mFlashAddress , 
+								apImagePartition->mLength
+							);
+				}
+				break;
+				case MTD_ID_EMMC_FLASH:
+				{
+					Status = cnc_EMMCVerify( apImagePartition->mDdrAddress , 
+								apImagePartition->mFlashAddress , 
+								apImagePartition->mLength
+							);
+				}
+				break;
+				case MTD_ID_INVALID:
+				{
+					printf("%sERROR: Invalid MTD_ID supplied%s\n", ColorRed, ColorNormal);
+					return -1;
+				}
+				break;
+				
+			}
+		}
+		break;		
+	}
+	return Status;
+}
+
+int do_cncflash(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
+{
+	UInt32 DdrAddress = 0;
+	int Status=0;
+	int i;
+	FLASH_MODE FlashMode = FLASH_MODE_INVALID;
+	MTD_ID MtdId = MTD_ID_INVALID;
+	ImagePartitionList_t mImagePartitionInfoList;
+	int ExpectedArgc = 5;
+
+	if (argc == 1)
+	{
+		PrintUsage(cmdtp);
+		return 0;
+	}
+	
+	memset( &mImagePartitionInfoList, 0, sizeof(mImagePartitionInfoList) );
+	Status = GenerateImagePartitionListFromBootArgs(getenv("bootargs"), & mImagePartitionInfoList);
+	if (Status == -1)
+	{
+		printf("%sERROR: error occured while parsing bootargs, please contact vendor\n%s", ColorRed, ColorNormal);
+		return -1;
+	}
+	
+	FlashMode = SearchExactStringInList( argv[1] , FlashModeList);
+	MtdId     = SearchExactStringInList( argv[2] , CncValidMtdIdList);
+
+	if( (FlashMode == FLASH_MODE_INVALID) || (  MtdId == MTD_ID_INVALID) )
+	{
+		printf("%sERROR: invalid operation or mtdid is specified\n%s", ColorRed, ColorNormal);
+		PrintUsage(cmdtp);
+		return -1;
+	}
+	
+	i= GetPartiotioIndex( & mImagePartitionInfoList , argv[2] , argv[3] );
+
+	if ( i== -1)
+	{
+		printf("%sERROR: invalid partition name or mtdid is specified\n%s", ColorRed, ColorNormal);
+		PrintUsage(cmdtp);
+		return -1;
+	}
+	
+	if (FlashMode == FLASH_MODE_ERASE)
+	{
+		ExpectedArgc--;
+	}
+	
+	if (argc < ExpectedArgc)
+	{
+		printf("%sERROR: please supply all argument\n%s", ColorRed, ColorNormal);
+		PrintUsage(cmdtp);
+		return -1;
+	}
+	
+	if ( FlashMode != FLASH_MODE_ERASE)
+	{
+		DdrAddress = simple_strtol(argv[4] , NULL,16);
+	}
+
+	mImagePartitionInfoList.mImagePartitionList[i].mDdrAddress = DdrAddress;
+
+	debug("%s ",  mImagePartitionInfoList.mImagePartitionList[i].mMtdId);
+	debug("%s ",  mImagePartitionInfoList.mImagePartitionList[i].mPartionName);
+	debug("%08x ",  mImagePartitionInfoList.mImagePartitionList[i].mFlashAddress);
+	debug("%08x ",  mImagePartitionInfoList.mImagePartitionList[i].mDdrAddress);
+	debug("%08x\n",  mImagePartitionInfoList.mImagePartitionList[i].mLength );
+	
+	if (argc == 6 )
+	{
+		if ( FlashMode == FLASH_MODE_ERASE)
+		{
+			printf("%sLength can not be changed to requested size, becuase cncflash operates on mtd partition so we can not use erase.spread%s\n", ColorYellow, ColorNormal );
+		}
+		else
+		{
+			mImagePartitionInfoList.mImagePartitionList[i].mLength = simple_strtol(argv[5], NULL, 16);
+			debug("Length is changed to %08x\n",  mImagePartitionInfoList.mImagePartitionList[i].mLength );
+		}
+	}
+
+	
+	Status = CncFlashTask( FlashMode, MtdId , & mImagePartitionInfoList.mImagePartitionList[i] , DdrAddress );
+	
+	return Status;
+}
+
+U_BOOT_CMD(
+	cncflash, 6, 0, do_cncflash,
+	"[read|write|erase] [cnc-nand|s25f|cnc-spi|cnc-nor|emmc] [partition_name] [DdrAddress]\n",
+	"[read|write|erase] [cnc-nand|s25f|cnc-spi|cnc-nor|emmc] [partition_name] [DdrAddress]\n"
+);
+
diff '--exclude=.svn' -Naur u-boot-2011.06_original/common/cmd_ColorOnOff.c u-boot-2011.06/common/cmd_ColorOnOff.c
--- u-boot-2011.06_original/common/cmd_ColorOnOff.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/common/cmd_ColorOnOff.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,54 @@
+/*
+ * Copyright 2000-2009
+ * Wolfgang Denk, DENX Software Engineering, wd@denx.de.
+ *
+ * See file CREDITS for list of people who contributed to this
+ * project.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of
+ * the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
+ * MA 02111-1307 USA
+ */
+
+#include <common.h>
+#include <command.h>
+#include <cnc_util.h>
+
+extern char version_string[];
+extern void ColorOn(void);
+extern void ColorOff(void);
+
+int do_coloron(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
+{
+	ColorOn();
+	puts("OK\n");
+	return 0;
+}
+int do_coloroff(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
+{
+	ColorOff();
+	puts("OK\n");
+	return 0;
+}
+
+U_BOOT_CMD(
+	coloron,	1,		1,	do_coloron,
+	"uboot with color",
+	""
+);
+U_BOOT_CMD(
+	coloroff,	1,		1,	do_coloroff,
+	"uboot nocolor",
+	""
+);
diff '--exclude=.svn' -Naur u-boot-2011.06_original/common/cmd_cslogo.c u-boot-2011.06/common/cmd_cslogo.c
